%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%if 0%{?fedora}
# There are some missing deps
%global with_python3 1
%endif

%global pypi_name os-brick

Name:           python-%{pypi_name}
Version:        1.11.0
Release:        6%{?dist}
Provides:        python2-os-brick = %{version}-%{release}
Summary:        OpenStack Cinder brick library for managing local volume attaches

License:        ASL 2.0
URL:            http://www.openstack.org/
Source0:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{version}.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=7b2d35f609c60f7cb6cddd8dba02fd3f688553e6
#
Patch0001: 0001-Fix-multipath-flush-when-using-friendly-names.patch
Patch0002: 0002-Retry-multipath-flush-when-map-is-in-use.patch
Patch0003: 0003-Fix-iSCSI-multipath-rescan.patch
Patch0004: 0004-Refactor-iSCSI-disconnect.patch
Patch0005: 0005-Refactor-iSCSI-connect.patch
Patch0006: 0006-Add-open-iscsi-manual-scan-support.patch
Patch0007: 0007-Fix-iSCSI-cleanup-issue-when-using-discovery.patch
Patch0008: 0008-iSCSI-multipath-improve-logging-on-connect.patch
Patch0009: 0009-Fix-manual-scan-for-discovery-type-backends.patch
Patch0010: 0010-Fix-iSCSI-cleanup-fix-on-discovery-backends.patch
Patch0011: 0011-Return-symlinks-for-encrypted-volumes.patch
Patch0012: 0012-Return-WWN-in-multipath_id.patch
Patch0013: 0013-Don-t-obscure-logs-on-iSCSI-sendtargets-failure.patch
Patch0014: 0014-Get-the-right-portal-from-output-of-iscsiadm-command.patch
Patch0015: 0015-Fix-ISCSIConnector._get_potential_volume_paths-logic.patch
Patch0016: 0016-FC-connector-logs-number-of-attempts-incorrectly.patch
Patch0017: 0017-Fix-iSCSI-volume-attachment-over-RDMA-transport.patch
Patch0018: 0018-Change-log-level-on-_get_hba_channel_scsi_target.patch
Patch0019: 0019-Protect-against-race-within-os.path.realpath.patch

BuildArch:      noarch

Provides:       os-brick = %{version}-%{release}
Requires:       python-babel >= 2.3.4
Requires:       python-eventlet >= 0.18.2
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-concurrency >= 3.8.0
Requires:       python-oslo-i18n >= 2.1.0
Requires:       python-oslo-log >= 3.11.0
Requires:       python-oslo-service >= 1.10.0
Requires:       python-oslo-utils >= 3.18.0
Requires:       python-requests >= 2.10.0
Requires:       python-retrying
Requires:       python-six >= 1.9.0
Requires:       python-oslo-privsep >= 1.9.0
Requires:       python-os-win >= 1.4.0
BuildRequires:  python2-devel
BuildRequires:  python-ddt
BuildRequires:  python-pbr >= 1.6.0
BuildRequires:  python-reno
BuildRequires:  python-sphinx
BuildRequires:  python-oslo-concurrency  >= 3.8.0
BuildRequires:  python-oslo-i18n >= 2.1.0
BuildRequires:  python-oslo-log >= 1.14.0
BuildRequires:  python-oslo-service >= 1.10.0
BuildRequires:  python-oslo-sphinx >= 2.5.0
BuildRequires:  python-requests >= 2.10.0
BuildRequires:  python-six >= 1.9.0
BuildRequires:  python-setuptools
BuildRequires:  python-oslo-privsep >= 1.9.0
%description
OpenStack Cinder brick library for managing local volume attaches

%if 0%{?with_python3}
%package -n python3-%{pypi_name}
Summary:        OpenStack Cinder brick library for managing local volume attaches
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3-babel >= 2.3.4
Requires:       python3-eventlet >= 0.18.2
Requires:       python3-oslo-serialization >= 1.10.0
Requires:       python3-oslo-concurrency >= 3.8.0
Requires:       python3-oslo-i18n >= 2.1.0
Requires:       python3-oslo-log >= 1.14.0
Requires:       python3-oslo-service >= 1.10.0
Requires:       python3-oslo-utils >= 3.16.0
Requires:       python3-requests >= 2.10.0
Requires:       python3-retrying
Requires:       python3-six >= 1.9.0
Requires:       python3-oslo-privsep >= 1.5.0
Requires:       python3-os-win

BuildRequires:  python3-devel
BuildRequires:  python3-ddt
BuildRequires:  python3-pbr >= 1.6.0
BuildRequires:  python3-reno
BuildRequires:  python3-sphinx
BuildRequires:  python3-oslo-concurrency  >= 3.8.0
BuildRequires:  python3-oslo-i18n >= 2.1.0
BuildRequires:  python3-oslo-log >= 1.14.0
BuildRequires:  python3-oslo-service >= 1.10.0
BuildRequires:  python3-oslo-sphinx >= 2.5.0
BuildRequires:  python3-requests >= 2.10.0
BuildRequires:  python3-six >= 1.9.0
BuildRequires:  python3-setuptools
BuildRequires:  python3-oslo-privsep >= 1.5.0

%description -n python3-%{pypi_name}
OpenStack Cinder brick library for managing local volume attaches

%endif

%prep
%setup -q -n %{pypi_name}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1

%build
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} build --executable="%{__python2} -s"
%if 0%{?with_python3}
%py3_build
%endif

%install
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} install -O1 --skip-build --root %{buildroot}
# generate html docs
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

%if 0%{?with_python3}
%py3_install
%endif

# Move config files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap
mv %{buildroot}/usr/etc/os-brick/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap

%files -n python-%{pypi_name}
%license LICENSE
%doc html README.rst
%{python2_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%exclude %{python2_sitelib}/os_brick/tests

%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%license LICENSE
%doc html README.rst
%{python3_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%exclude %{python3_sitelib}/os_brick/tests
%endif

%changelog
* Tue Oct 24 2017 Gorka Eguileor <geguileo@redhat.com> 1.11.0-6
- Protect against race within os.path.realpath (RHBZ#1503258)

* Thu Sep 14 2017 Eric Harney <eharney@redhat.com> 1.11.0-5
- Change log level on _get_hba_channel_scsi_target (RHBZ #1487582)

* Fri Aug 25 2017 Gorka Eguileor <geguileo@redhat.com> 1.11.0-4
- Fix iSCSI volume attachment over RDMA transport (RHBZ#1484431)

* Thu Aug 17 2017 Eric Harney <eharney@redhat.com> 1.11.0-3
- Fix logging for FC discovery retries (RHBZ #1479368)

* Thu Aug 10 2017 Gorka Eguileor <geguileo@redhat.com> 1.11.0-2
- Fix ISCSIConnector._get_potential_volume_paths logic (RHBZ#1443612)
- Get the right portal from output of iscsiadm command (RHBZ#1443612)
- Don't obscure logs on iSCSI sendtargets failure (RHBZ#1443612)
- Return WWN in multipath_id (RHBZ#1443612)
- Return symlinks for encrypted volumes (RHBZ#1443612)
- Fix iSCSI cleanup fix on discovery backends (RHBZ#1443612)
- Fix manual scan for discovery type backends (RHBZ#1443612)
- iSCSI multipath: improve logging on connect (RHBZ#1443612)
- Fix iSCSI cleanup issue when using discovery (RHBZ#1443612)
- Add open-iscsi manual scan support (RHBZ#1443612)
- Refactor iSCSI connect (RHBZ#1443612)
- Refactor iSCSI disconnect (RHBZ#1443612)
- Fix iSCSI multipath rescan (RHBZ#1443612)
- Retry multipath flush when map is in use
- Fix multipath flush when using friendly names

* Wed Feb 08 2017 Alfredo Moralejo <amoralej@redhat.com> 1.11.0-1
- Update to 1.11.0

